;/*****************************************************************************
;   
;   Copyright (c) 2004-2011 SMSC. All rights reserved.
;
;   Use of this source code is subject to the terms of the SMSC Software
;   License Agreement (SLA) under which you licensed this software product.  
;   If you did not accept the terms of the SLA, you are not authorized to use
;   this source code. 
;
;   This code and information is provided as is without warranty of any kind,
;   either expressed or implied, including but not limited to the implied
;   warranties of merchantability and/or fitness for a particular purpose.
;    
;*****************************************************************************/
    AREA    |text|, CODE, READONLY, ALIGN=5

    EXPORT  CleanCacheLine
    EXPORT  DrainWriteBuffers
    EXPORT  GetCPSR
    EXPORT  GetTTB
    EXPORT  GetPID
    EXPORT  ReadCLKCFG
    EXPORT  DisableCPUInt
    EXPORT  EnableCPUInt

CleanCacheLine  FUNCTION
    mcr p15, 0, r0, c7, c10, 1
    mcr p15, 0, r0, c7, c6, 1

    mov pc, lr
    ENDFUNC

DrainWriteBuffers
    mcr p15, 0, r0, c7, c10, 4
    
    mov pc, lr
    ENDFUNC

GetCPSR
    mrs r0, cpsr

    mov pc, lr
    ENDFUNC

GetTTB
    mrc p15, 0, r0, c2, c0, 0
    mov pc, lr  
    ENDFUNC

GetPID
    mrc p15, 0, r0, c13, c0, 0
    mov pc, lr
    ENDFUNC

ReadCLKCFG
    mrc  p14, 0, r0, c6, c0, 0
    mov  pc, lr
    ENDFUNC

DisableCPUInt
    mrs  r0, cpsr
    orr  r1, r0, #0x80
    msr  cpsr, r1
    mov  pc, lr
    ENDFUNC

EnableCPUInt
    mrs  r0, cpsr
    bic  r1, r0, #0x80
    msr  cpsr, r1
    mov  pc, lr
    ENDFUNC

    END

